/**************************************************************
** 	MINI
**	LCD
**  汾V1.0  
**	̳www.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  ֧Ⱥ121939788 
***************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware_conf.h"
#include "ili932x_conf.h"
#include "Font_Lib.h"	 //ֿļ
#include "hz16.h"

uint16_t DeviceCode;
uint8_t Data_Bus16 =0;  //8λת16ӿʹ
uint8_t Data_Bus8 = 0;  //8λӿʹ

uint16_t Point_Color = BLUE,Back_Color = BLACK;  /* ֱõɫ͵ɫ	*/

/*****************************************************************************
** : LCD_Write_Reg
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_Dat)
{
	Write_Cmd(LCD_Reg);
	Write_Dat(LCD_Dat);
}
/*****************************************************************************
** : Write_Cmd
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Cmd(uint16_t LCD_Reg)
{
	if(Data_Bus8 ==0)
	{
		if(Data_Bus16 ==1)
		{					 
			LCD_CS = 0;
			LCD_RS = 0;
			GPIOB->ODR = (GPIOB->ODR&0X00FF)|(LCD_Reg<<8); 	 //ȴ͵8λ
			LCD_LE = 1;
			__nop();
			__nop();
			__nop();
			LCD_LE = 0;
			__nop();
			__nop();
			__nop();
			GPIOB->ODR = (GPIOB->ODR&0X00FF)|LCD_Reg; 		 //͸8λ
			LCD_WR = 0;
			LCD_WR = 1;	
			LCD_CS = 1;	
		 }
		 else
		 {
			LCD_CS = 0;
			LCD_RS = 0;
			GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Reg&0x00ff);
			GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Reg&0xff00);
			LCD_WR = 0;
			LCD_WR = 1;	
			LCD_CS = 1;	  
		} 
	}
	else
	{
		LCD_WR = 1;	
		LCD_CS = 0;
		LCD_RS = 0;
	    GPIOB->ODR=(GPIOB->ODR&0X00FF)|LCD_Reg;
		LCD_WR = 0;
		LCD_WR = 1;
	    GPIOB->ODR=(GPIOB->ODR&0X00FF)|(LCD_Reg<<8);
		LCD_WR = 0;
		LCD_WR = 1;	
		LCD_CS = 1;
	}
}
/*****************************************************************************
** : Write_Dat
** : д
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Dat(uint16_t LCD_Dat)
{
	if(Data_Bus8 ==0)
	{
		if(Data_Bus16==1)
		{
			LCD_CS = 0;
			LCD_RS = 1;
			GPIOB->ODR = (GPIOB->ODR&0X00FF)|(LCD_Dat<<8); 	//ȴ͵8λ
			LCD_LE = 1;
			__nop();
			__nop();
			__nop();
			LCD_LE = 0;
			__nop();
			__nop();
			__nop();
			GPIOB->ODR = (GPIOB->ODR&0X00FF)|LCD_Dat; 		//͸8λ
			LCD_WR = 0;
			LCD_WR = 1;	
			LCD_CS = 1;  
		}
		else
		{	
			LCD_CS = 0;
			LCD_RS = 1;
			GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Dat&0x00ff);
			GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Dat&0xff00);
			LCD_WR = 0;
			LCD_WR = 1;	
			LCD_CS = 1;	  
		}	 
	}
	else
	{
		LCD_CS = 0;
		LCD_RS = 1;
	    GPIOB->ODR=(GPIOB->ODR&0X00FF)| LCD_Dat;
		LCD_WR = 0;
		LCD_WR = 1;	
	    GPIOB->ODR=(GPIOB->ODR&0X00FF)|(LCD_Dat<<8);
		LCD_WR = 0;
		LCD_WR = 1;	
		LCD_CS = 1;
	}
}
/*****************************************************************************
** : LCD_ReadReg
** : ָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadReg(uint16_t LCD_Reg)
{
	uint16_t temp;
	Write_Cmd(LCD_Reg);  //дҪļĴ  

	if(Data_Bus8 ==0)
	{
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڸ8λó
		GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x44444444; //˿ڵ8λó  
		LCD_CS = 0;
		LCD_RS = 1;
		LCD_RD = 0;
		temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff)); 	//ȡ(Ĵʱ,Ҫ2) 	
		LCD_RD = 1;
		LCD_CS = 1; 
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڸ8λΪ
		GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ
	}
	else
	{
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڸ8λó
		LCD_CS = 0;
		LCD_RS = 0;
		LCD_RD = 0;
		temp = (0xff00&GPIOB->IDR); //ȡ(Ĵʱ,Ҫ2) 		
		LCD_RD = 1;
		LCD_RD = 0;
		temp |= ((0xff00&GPIOB->IDR)>>8); //ȡ(Ĵʱ,Ҫ2) 	
		LCD_RD = 1;
		LCD_CS = 1; 
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ	
	}
	return temp;  
}	
/*****************************************************************************
** : LCD_ReadDat
** : 
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadDat()
{
	uint16_t temp;
	if(Data_Bus8 ==0)
	{
	
		GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x44444444;  //˿ڸ8λó
		GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x44444444;  //˿ڵ8λó
		LCD_CS = 0;
		LCD_WR = 1;
		LCD_RS = 1;
		LCD_RD = 0;
		temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff));	//ȡ(Ĵʱ,Ҫ2)
		LCD_RD = 1;
		LCD_CS = 1;
		GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x33333333;  //ͷŶ˿ڸ8λΪ
		GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x33333333;  //ͷŶ˿ڵ8λΪ
	}
	else
	{
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڵ8λó
		LCD_CS = 0;
		LCD_RS = 1;
		temp = (0xff00&GPIOB->IDR); //ȡ(Ĵʱ,Ҫ2) 	
		LCD_RD = 1;
		LCD_RD = 0;
		temp |= ((0xff00&GPIOB->IDR)>>8); //ȡ(Ĵʱ,Ҫ2) 	
		LCD_RD = 1;
		LCD_CS = 1;
		LCD_CS = 1;
		GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ
	}
	return temp; 	   
}	   
/*****************************************************************************
** : LCD_Configuration
** : LCD_IO
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Configuration()
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);

	/* IO ӵGPIOB *********************/	
	GPIO_InitStructure.GPIO_Pin =GPIO_Pin_5 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 
								| GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* ÿIO ӵPD12.PD13.PD14.PD15 *********************/	
	GPIO_InitStructure.GPIO_Pin =GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 |GPIO_Pin_4
								| GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 
								| GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOC, &GPIO_InitStructure);
//	LCD_LE = 0;	 
}
/*****************************************************************************
** : LCD_Init
** : LCDʼ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Init(void)
{
	LCD_Configuration();
	LCD_WriteReg(0x0000,0x0001);
	LCD_Delay(5); 		// LCD_Delay 50 ms 
	DeviceCode = LCD_ReadReg(0x0000); 
	if(DeviceCode==0x9325||DeviceCode==0x9328)////ӦICΪILI93259328
	{

		LCD_WriteReg(0x00E3,0x3008);        
		LCD_WriteReg(0x00E7,0x0012);
		LCD_WriteReg(0x00Ef,0x1231); 	// Set the internal timing;    
        LCD_WriteReg(0x00,0x0001);
        LCD_WriteReg(0x01, 0x0000); // set SS and SM bit
        LCD_WriteReg(0x02, 0x0700); // set 1 line inversion
        //LCD_WriteReg(0x03, 0x10B0); // set GRAM write direction and BGR=1.
#if   ID_AM==000       
	     LCD_WriteReg(0x0003,0x1000);//Ļת TFM=0,TRI=0,SWAP=1,16 bits system interface  swap RGB to BRG˴ORGHWM Ϊ0
#elif ID_AM==001        
	     LCD_WriteReg(0x0003,0x1008);      
#elif ID_AM==010  
	     LCD_WriteReg(0x0003,0x1010);        
#elif ID_AM==011
	     LCD_WriteReg(0x0003,0x1018);
#elif ID_AM==100  
	     LCD_WriteReg(0x0003,0x1020);      
#elif ID_AM==101  
	     LCD_WriteReg(0x0003,0x1028);      
#elif ID_AM==110  
	     LCD_WriteReg(0x0003,0x1030);      
#elif ID_AM==111  
	     LCD_WriteReg(0x0003,0x1038);
#endif    
         LCD_WriteReg(0x04, 0x0000); // Resize register
         LCD_WriteReg(0x08, 0x0404); // set the back porch and front porch
         LCD_WriteReg(0x09, 0x0000); // set non-display area refresh cycle ISC[3:0]
         LCD_WriteReg(0x0A, 0x0000); // FMARK function
        // LCD_WriteReg(0x0C, 0x0000); // RGB interface setting
        // LCD_WriteReg(0x0D, 0x0000); // Frame marker Position
        // LCD_WriteReg(0x0F, 0x0000); // RGB interface polarity
//Power On sequence //
         LCD_WriteReg(0x10, 0x0080); // SAP, BT[3:0], AP, DSTB, SLP, STB
         LCD_WriteReg(0x11, 0x0007); // DC1[2:0], DC0[2:0], VC[2:0]
         LCD_WriteReg(0x12, 0x0000); // VREG1OUT voltage
         LCD_WriteReg(0x13, 0x0000); // VDV[4:0] for VCOM amplitude
	 	 LCD_WriteReg(0x07, 0x0001); // 
		 
         LCD_Delay(5); // Dis-charge capacitor power voltage
         
         LCD_WriteReg(0x10, 0x1590); // SAP, BT[3:0], AP, DSTB, SLP, STB
         LCD_WriteReg(0x11, 0x0227); // DC1[2:0], DC0[2:0], VC[2:0]
         LCD_Delay(5); // Delay 50ms
        
         LCD_WriteReg(0x12, 0x001F); // Internal reference voltage= Vci;
         LCD_Delay(5); // Delay 50ms
         LCD_WriteReg(0x13, 0x1500); // Set VDV[4:0] for VCOM amplitude
         LCD_WriteReg(0x29, 0x0022); // Set VCM[5:0] for VCOMH
         LCD_WriteReg(0x2B, 0x000f); // Set Frame Rate
         LCD_Delay(5);// Delay 580ms
         
#if   ID_AM==000         
	     LCD_WriteReg(0x0020,0x00ef);//GRAMˮƽʼλ
	     LCD_WriteReg(0x0021,0x013f);      
#elif ID_AM==001
	     LCD_WriteReg(0x0020,0x00ef);
	     LCD_WriteReg(0x0021,0x013f);      
#elif ID_AM==010
	     LCD_WriteReg(0x0020,0x0000);
	     LCD_WriteReg(0x0021,0x013f);      
#elif ID_AM==011
	     LCD_WriteReg(0x0020,0x0000);
	     LCD_WriteReg(0x0021,0x013f);       
#elif ID_AM==100
	     LCD_WriteReg(0x0020,0x00ef);
	     LCD_WriteReg(0x0021,0x0000);      
#elif ID_AM==101  
	     LCD_WriteReg(0x0020,0x00ef);
	     LCD_WriteReg(0x0021,0x0000);      
#elif ID_AM==110
	     LCD_WriteReg(0x0020,0x0000);
	     LCD_WriteReg(0x0021,0x0000);      
#elif ID_AM==111
	     LCD_WriteReg(0x0020,0x0000);
	     LCD_WriteReg(0x0021,0x0000);         
#endif  
// ----------- Adjust the Gamma Curve ----------//
		LCD_WriteReg(0x0030,0x0101);
		LCD_WriteReg(0x0031,0x0707);
		LCD_WriteReg(0x0032,0x0505);
		LCD_WriteReg(0x0035,0x0407);
		LCD_WriteReg(0x0036,0x0102);
		LCD_WriteReg(0x0037,0x0102);
		LCD_WriteReg(0x0038,0x0202);
		LCD_WriteReg(0x0039,0x0106);
		LCD_WriteReg(0x003C,0x0202);
		LCD_WriteReg(0x003D,0x0706);
//------------------ Set GRAM area ---------------//
         LCD_WriteReg(0x0050, 0x0000); // Horizontal GRAM Start Address
         LCD_WriteReg(0x0051, 0x00EF); // Horizontal GRAM End Address
         LCD_WriteReg(0x0052, 0x0000); // Vertical GRAM Start Address
         LCD_WriteReg(0x0053, 0x013F); // Vertical GRAM Start Address
         LCD_WriteReg(0x0060, 0xA700); // Gate Scan Line
         LCD_WriteReg(0x0061, 0x0001); // NDL,VLE, REV
         LCD_WriteReg(0x006A, 0x0000); // set scrolling line
//-------------- Partial Display Control ---------//
         LCD_WriteReg(0x80, 0x0000);
         LCD_WriteReg(0x81, 0x0000);
         LCD_WriteReg(0x82, 0x0000);
         LCD_WriteReg(0x83, 0x0000);
         LCD_WriteReg(0x84, 0x0000);
         LCD_WriteReg(0x85, 0x0000);
//-------------- Panel Control -------------------//
         LCD_WriteReg(0x90, 0x0010);
         LCD_WriteReg(0x92, 0x0000);
         LCD_WriteReg(0x93, 0x0003);
         LCD_WriteReg(0x95, 0x0110);
         LCD_WriteReg(0x97, 0x0000);
         LCD_WriteReg(0x98, 0x0000);
         LCD_WriteReg(0x07, 0x0173); // 262K color and display ON   0133
	}
	else if(DeviceCode==0x9320||DeviceCode==0x9300)	 //ӦICΪILI9320ILI9300
	{
		LCD_WriteReg(0x00,0x0000);
		LCD_WriteReg(0x01,0x0100);	//Driver Output Contral.
		LCD_WriteReg(0x02,0x0700);	//LCD Driver Waveform Contral.
		LCD_WriteReg(0x03,0x1030);//Entry Mode Set.
		//LCD_WriteReg(0x03,0x1018);	//Entry Mode Set.
	
		LCD_WriteReg(0x04,0x0000);	//Scalling Contral.
		LCD_WriteReg(0x08,0x0202);	//Display Contral 2.(0x0207)
		LCD_WriteReg(0x09,0x0000);	//Display Contral 3.(0x0000)
		LCD_WriteReg(0x0a,0x0000);	//Frame Cycle Contal.(0x0000)
		LCD_WriteReg(0x0c,(1<<0));	//Extern Display Interface Contral 1.(0x0000)
		LCD_WriteReg(0x0d,0x0000);	//Frame Maker Position.
		LCD_WriteReg(0x0f,0x0000);	//Extern Display Interface Contral 2.	    
		LCD_Delay(10); 
		LCD_WriteReg(0x07,0x0101);	//Display Contral.
		LCD_Delay(10); 								  
		LCD_WriteReg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4));	//Power Control 1.(0x16b0)
		LCD_WriteReg(0x11,0x0007);								//Power Control 2.(0x0001)
		LCD_WriteReg(0x12,(1<<8)|(1<<4)|(0<<0));				//Power Control 3.(0x0138)
		LCD_WriteReg(0x13,0x0b00);								//Power Control 4.
		LCD_WriteReg(0x29,0x0000);								//Power Control 7.
	
		LCD_WriteReg(0x2b,(1<<14)|(1<<4));	    
		LCD_WriteReg(0x50,0);	//Set X Star
		//ˮƽGRAMֹλSet X End.
		LCD_WriteReg(0x51,239);	//Set Y Star
		LCD_WriteReg(0x52,0);	//Set Y End.t.
		LCD_WriteReg(0x53,319);	//
	
		LCD_WriteReg(0x60,0x2700);	//Driver Output Control.
		LCD_WriteReg(0x61,0x0001);	//Driver Output Control.
		LCD_WriteReg(0x6a,0x0000);	//Vertical Srcoll Control.
	
		LCD_WriteReg(0x80,0x0000);	//Display Position? Partial Display 1.
		LCD_WriteReg(0x81,0x0000);	//RAM Address Start? Partial Display 1.
		LCD_WriteReg(0x82,0x0000);	//RAM Address End-Partial Display 1.
		LCD_WriteReg(0x83,0x0000);	//Displsy Position? Partial Display 2.
		LCD_WriteReg(0x84,0x0000);	//RAM Address Start? Partial Display 2.
		LCD_WriteReg(0x85,0x0000);	//RAM Address End? Partial Display 2.
	
		LCD_WriteReg(0x90,(0<<7)|(16<<0));	//Frame Cycle Contral.(0x0013)
		LCD_WriteReg(0x92,0x0000);	//Panel Interface Contral 2.(0x0000)
		LCD_WriteReg(0x93,0x0001);	//Panel Interface Contral 3.
		LCD_WriteReg(0x95,0x0110);	//Frame Cycle Contral.(0x0110)
		LCD_WriteReg(0x97,(0<<8));	//
		LCD_WriteReg(0x98,0x0000);	//Frame Cycle Contral.	   
		LCD_WriteReg(0x07,0x0173);	//(0x0173)
		LCD_Delay(10);
	}
	else if(DeviceCode==0x8999)	   //ӦICΪSSD1289
	{
		//************* Start Initial Sequence **********//
		LCD_WriteReg(0x00, 0x0001); // Start internal OSC.
		LCD_WriteReg(0x01, 0x3B3F); // Driver output control, RL=0;REV=1;GD=1;BGR=0;SM=0;TB=1
		LCD_WriteReg(0x02, 0x0600); // set 1 line inversion
		//************* Power control setup ************/
		LCD_WriteReg(0x0C, 0x0007); // Adjust VCIX2 output voltage
		LCD_WriteReg(0x0D, 0x0006); // Set amplitude magnification of VLCD63
		LCD_WriteReg(0x0E, 0x3200); // Set alternating amplitude of VCOM
		LCD_WriteReg(0x1E, 0x00BB); // Set VcomH voltage
		LCD_WriteReg(0x03, 0x6A64); // Step-up factor/cycle setting
		//************ RAM position control **********/
		LCD_WriteReg(0x0F, 0x0000); // Gate scan position start at G0.
		LCD_WriteReg(0x44, 0xEF00); // Horizontal RAM address position
		LCD_WriteReg(0x45, 0x0000); // Vertical RAM address start position
		LCD_WriteReg(0x46, 0x013F); // Vertical RAM address end position
		// ----------- Adjust the Gamma Curve ----------//
		LCD_WriteReg(0x30, 0x0000);
		LCD_WriteReg(0x31, 0x0706);
		LCD_WriteReg(0x32, 0x0206);
		LCD_WriteReg(0x33, 0x0300);
		LCD_WriteReg(0x34, 0x0002);
		LCD_WriteReg(0x35, 0x0000);
		LCD_WriteReg(0x36, 0x0707);
		LCD_WriteReg(0x37, 0x0200);
		LCD_WriteReg(0x3A, 0x0908);
		LCD_WriteReg(0x3B, 0x0F0D);
		//************* Special command **************/
		LCD_WriteReg(0x28, 0x0006); // Enable test command
		LCD_WriteReg(0x2F, 0x12EB); // RAM speed tuning
		LCD_WriteReg(0x26, 0x7000); // Internal Bandgap strength
		LCD_WriteReg(0x20, 0xB0E3); // Internal Vcom strength
		LCD_WriteReg(0x27, 0x0044); // Internal Vcomh/VcomL timing
		LCD_WriteReg(0x2E, 0x7E45); // VCOM charge sharing time  
		//************* Turn On display ******************/
		LCD_WriteReg(0x10, 0x0000); // Sleep mode off.
		LCD_Delay(8); // Wait 30mS
		LCD_WriteReg(0x11, 0x6870); // Entry mode setup. 262K type B, take care on the data bus with 16it only
		LCD_WriteReg(0x07, 0x0033); // Display ON	*/
		//W_C(0x22);//		   delay(50);
	}
	else if(DeviceCode==0x9919)	   //ӦICΪSSD2119
	{
		//*********POWER ON &RESET DISPLAY OFF
		 LCD_WriteReg(0x28,0x0006);
		
		 LCD_WriteReg(0x00,0x0001);
		
		 LCD_WriteReg(0x10,0x0000);
		
		 LCD_WriteReg(0x01,0x72ef);	 //REVɫת

		 LCD_WriteReg(0x02,0x0600);

		 LCD_WriteReg(0x03,0x6a38);
		
		 LCD_WriteReg(0x11,0x6874);//70	
		 
		     //  RAM WRITE DATA MASK
		 LCD_WriteReg(0x0f,0x0000); 
		    //  RAM WRITE DATA MASK
		 LCD_WriteReg(0x0b,0x5308); 
		
		 LCD_WriteReg(0x0c,0x0003);
		
		 LCD_WriteReg(0x0d,0x000a);
		
		 LCD_WriteReg(0x0e,0x2e00);  //0030
		
		 LCD_WriteReg(0x1e,0x00be);
		
		 LCD_WriteReg(0x25,0x8000);
		
		 LCD_WriteReg(0x26,0x7800);
		
		 LCD_WriteReg(0x27,0x0078);
		
		 LCD_WriteReg(0x4e,0x0000);
		
		 LCD_WriteReg(0x4f,0x0000);
		
		 LCD_WriteReg(0x12,0x08d9);
		
		 // -----------------Adjust the Gamma Curve----//
		 LCD_WriteReg(0x30,0x0000);	 //0007
		
		 LCD_WriteReg(0x31,0x0104);	   //0203
		
		 LCD_WriteReg(0x32,0x0100);		//0001

		 LCD_WriteReg(0x33,0x0305);	  //0007

		 LCD_WriteReg(0x34,0x0505);	  //0007
		
		 LCD_WriteReg(0x35,0x0305);		 //0407
		
		 LCD_WriteReg(0x36,0x0707);		 //0407
		
		 LCD_WriteReg(0x37,0x0300);		  //0607
		
		 LCD_WriteReg(0x3a,0x1200);		 //0106
		
		 LCD_WriteReg(0x3b,0x0800);		 

		 LCD_WriteReg(0x07,0x0033);
	}
	LCD_Clear(Back_Color);	
}
/*****************************************************************************
** : LCD_DrawPoint
** : дһ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DrawPoint(uint16_t x,uint16_t y)
{
	LCD_SetCursor(x,y);//ùλ 
	Write_Cmd(0x22);//ʼдGRAM
	Write_Dat(Point_Color); 	
}
/*****************************************************************************
** : LCD_WriteRAM_Prepare
** : Щ׼
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteRAM_Prepare()
{
	Write_Cmd(0x22);	
}
/*****************************************************************************
** : LCD_SetCursor
** : ù꺯
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_SetCursor(uint16_t Xpos,uint16_t Ypos)
{
	if(DeviceCode==0x8989|DeviceCode==0x8999)
	{
	 	LCD_WriteReg(0x004e,Xpos);        //
    	LCD_WriteReg(0x004f,0x13f-Ypos);  //
	}
#if   ID_AM==000       
	LCD_WriteReg(R32, Xpos);
	LCD_WriteReg(R33, Ypos);

#elif ID_AM==001  
	LCD_WriteReg(R32, 239-Xpos);
	LCD_WriteReg(R33, 319-Ypos);
#endif 
} 
/*****************************************************************************
** : LCD_SetDisplayWindow
** : ôں (WidthHeightһ£ǰ)
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_SetDisplayWindow(uint16_t Xpos, uint16_t Ypos, uint16_t Height, uint16_t Width)
{
  	LCD_WriteReg(0x50, Xpos);	   	   	//ˮƽGRAMʼַ
  	LCD_WriteReg(0x51, Xpos+Height); 	//ˮƽGRAMַ 
  	LCD_WriteReg(0x52, Ypos);		  	//ֱGRAMʼַ
  	LCD_WriteReg(0x53, Ypos+Width);  	//ֱGRAMַ

//  	LCD_SetCursor(Xpos, Ypos);			//ùλ
}
/*****************************************************************************
** : LCD_ShowString
** : ʾַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 304 
void LCD_ShowString(uint8_t x,uint16_t y,uint8_t *p)
{         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}
        LCD_ShowChar(x,y,*p,16,0);
        x+=8;
        p++;
    }  
}
/*****************************************************************************
** : LCD_ShowChar
** : ʾһַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_ShowChar(uint8_t x,uint16_t y,uint8_t chars,uint8_t size,uint8_t mode)
{
	uint8_t temp;
    uint8_t pos,t;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY) return;	    
											
	LCD_SetDisplayWindow(x,y,(size/2-1),size-1);  //ô

	LCD_WriteRAM_Prepare();        //ʼдGRAM	   
	if(!mode) 						//ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=ASCII_1206[chars-0x20][pos];//1206
			else temp=ASCII_1608[chars-0x20][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {     
		        //if(temp&0x01)            	 			//ȴλȡģйϵ
		        if((temp<<t)&0x80)						//ȴλ
				{
					Write_Dat(RED);
				}
				else 
				{
					Write_Dat(WHITE);	        
		        }
				//temp>>=1; 	   							//ȴλȥ
		    }
		}	
	}
	else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=ASCII_1206[chars-0x20][pos];	//1206
			else temp=ASCII_1608[chars-0x20][pos];		 	//1608
			for(t=0;t<size/2;t++)
		    {                 
		        if((temp<<t)&0x80)LCD_DrawPoint(x+t,y+pos);	//һ     
		        //temp>>=1; 								//ȴλȥ
		    }
		}
	}	   
	LCD_SetDisplayWindow(0x00,0x00,0xEF,0x13F);	 //ָС		 	
}
/*****************************************************************************
** : LCD_Clear
** : Ļ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Clear(uint16_t Color)
{
	uint32_t index=0;      
	LCD_SetCursor(0x0000,0x0000); //ùλ 
	LCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<76800;index++)
	{
		Write_Dat(Color);    
	}
}
/*****************************************************************************
** : WriteString
** : ָλÿʼʾһַһ
				֧Զ
**   : Dream
** ա  : 20101206
*****************************************************************************/   			   
void WriteString(uint16_t x0, uint16_t y0,uint8_t *pcStr, uint16_t color)
{
	uint16_t usIndex;
    uint16_t usWidth = 0;
    FNT_GB16 *ptGb16 = 0;
    
    ptGb16 = (FNT_GB16 *)GBHZ_16;  
	while(1)
    {
        if(*pcStr == 0) 
		{
            break;                                     /* ַ            */
        }      
        x0 = x0 + (usWidth);                           /* ַʾɽ         */
        if(*pcStr > 0x80)                              /* жΪ                   */
        {
		    if((x0 + 16) > LCD_W)                      /* ʣռǷ㹻         */
            {
			    x0 = 0;
                y0 = y0 + 16;                          /* ıʾ                 */
                if(y0 > LCD_H)                         /* 곬                   */
                {
				    y0 = 0;
                }
            }
            usIndex = findHzIndex(pcStr);
            usWidth = WriteOneHzChar((uint8_t *)&(ptGb16[usIndex].Msk[0]), x0, y0, color);
                                                       /* ʾַ                     */
            pcStr += 2;
        }
		else 
		{                                               /* жΪǺ                 */
            if (*pcStr == '\r')                         /*                          */
            { 
			    y0 = y0 + 16;                           /* ıʾ                 */
                if(y0 > LCD_H)                          /* 곬                   */
                {
				    y0 = 0;
                }
                pcStr++;
                usWidth = 0;
                continue;
            } 
			else if (*pcStr == '\n')                    /* 뵽                   */
            {
			    x0 = 0;
                pcStr++;
                usWidth = 0;
                continue;
            } 
			else 
			{
                if((x0 + 8) > LCD_W)                     /* ʣռǷ㹻         */
                {
				    x0 = 0;
                    y0 = y0 + 16;                        /* ıʾ                 */
                    if(y0 > LCD_H)                       /* 곬                   */
                    { 
					    y0 = 0;
                    }
                }
                usWidth = WriteOneASCII((uint8_t *)&ASCII_1608[(*pcStr - 0x20)][0], x0, y0, color);
                                                         /* ASCII21HֵӦλ3*/
                pcStr += 1;
            }
		}
	}												  	  
}
/*****************************************************************************
** : WriteOneHzChar
** : ʾһָСĺ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t WriteOneHzChar(uint8_t *pucMsk,
                               uint16_t x0,
                               uint16_t y0,
                               uint16_t color)
{
    uint16_t i,j;
    uint16_t mod[16];                                      /* ǰģ                     */
    uint16_t *pusMsk;                                      /* ǰַֿ                 */
    uint16_t y;
    
    pusMsk = (uint16_t *)pucMsk;
    for(i=0; i<16; i++)                                    /* 浱ǰֵʽģ       */
    {
        mod[i] = *pusMsk++;                                /* ȡõǰģֶ   */
        mod[i] = ((mod[i] & 0xff00) >> 8) | ((mod[i] & 0x00ff) << 8);/* ģߵֽڣΪʾ   */
                                                           /* Ҫ                       */
    }
    y = y0;
    for(i=0; i<16; i++)                                    /* 16                         */
    { 
	    #ifdef __DISPLAY_BUFFER                            /* ʹԴʾ                 */
        for(j=0; j<16; j++)                                /* 16                         */
        {
		    if((mod[i] << j)& 0x8000)                      /* ʾģ                     */
            {
			    DispBuf[240*(y0+i) + x0+j] = color;
            }
        }
        #else                                              /* ֱʾ                     */
#if   ID_AM==000               
        LCD_SetCursor(x0, y);                              /* дݵַָ */

#elif ID_AM==001  
        LCD_SetCursor(y, x0);                              /* дݵַָ */
#endif        
		LCD_WriteRAM_Prepare();        					   /*ʼдGRAM	*/   
        for(j=0; j<16; j++)                                /* 16                         */
        {
		    if((mod[i] << j) & 0x8000)                     /* ʾģ                     */
            { 
			    Write_Dat(color);
            } 
			else 
			{
                Write_Dat(Back_Color);                     
            	//LCD_ReadDat();							   /* öʽдհ׵   */
			}
        }
        y++;
        #endif
    }
    return (16);                                          /* 16λп                 */
}
/*****************************************************************************
** : WriteOneASCII
** : ʾһָСַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t WriteOneASCII(uint8_t *pucMsk,
                              uint16_t x0,
                              uint16_t y0,
                              uint16_t color)
{
    uint16_t i,j;
    uint16_t y;
    uint8_t ucChar;
    
    y = y0;
    for(i=0; i<16; i++) {                                 /* 16                         */
        ucChar = *pucMsk++;
        #ifdef __DISPLAY_BUFFER                           /* ʹԴʾ                 */
        for(j=0; j<8; j++) {                              /* 8                          */
            if((ucChar << j)& 0x80) {                     /* ʾģ                     */
                DispBuf[240*(y0+i) + x0+j] = color;
            }
        }
        #else                                             /* ֱʾ                     */
        
#if   ID_AM==000               
        LCD_SetCursor(x0, y);                              /* дݵַָ */

#elif ID_AM==001 
        LCD_SetCursor(y, x0);                              /* дݵַָ */
#endif
		LCD_WriteRAM_Prepare();        					  /* ʼдGRAM	    		  */
        for(j=0; j<8; j++) {                              /* 8                          */
            if((ucChar << j) & 0x80) {                    /* ʾģ                     */
                Write_Dat(color);
            } 
			else 
			{
                Write_Dat(Back_Color);
				//LCD_ReadDat();						  	  /* öʽдհ׵   */
            }
        }
        y++;
        #endif
    }
    return (8);                                           /* 16λп                 */
}
/*****************************************************************************
** : Num_power
** : MNη
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint32_t Num_power(uint8_t m,uint8_t n)
{
	uint32_t result=1;	 
	while(n--)result*=m;    
	return result;
}
/*****************************************************************************
** : LCD_ShowNum
** : ָλʾһ
				num:ֵ(0~4294967295);
**   : Dream
** ա  : 20101206
*****************************************************************************/	 
void LCD_ShowNum(uint8_t x,uint16_t y,uint32_t num,uint8_t len,uint8_t size)
{         	
	uint8_t t,temp;
	uint8_t enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/Num_power(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
}
/*****************************************************************************
** : LCD_WriteBMP
** : ָλʾһͼƬ
				XposYposΪͼƬʾַHeightWidth ΪͼƬĿȺ͸߶
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DisplyBMP(uint8_t Xpos, uint16_t Ypos, uint8_t Height, uint16_t Width, uint8_t *bitmap)
{
  	uint32_t index;
  	uint32_t size = Height * Width;
  	uint16_t *bitmap_ptr = (uint16_t *)bitmap;
	
	LCD_SetDisplayWindow(Xpos, Ypos, Width-1, Height-1);

    LCD_WriteReg(0x20,Xpos);        //
  	LCD_WriteReg(0x21,Ypos);  //

  	//LCD_WriteReg(0x03, 0x1038);	//ҪʾͼƬȥ ͬʱWidthHightһ¾Ϳ

  	LCD_WriteRAM_Prepare();

  	for(index = 0; index < size; index++)
  	{
    	Write_Dat(*bitmap_ptr++);
  	}
	//ָС	 
	LCD_WriteReg(0x50, 0x0000); //ˮƽGRAMʼַ
	LCD_WriteReg(0x51, 0x00EF); //ˮƽGRAMַ
	LCD_WriteReg(0x52, 0x0000); //ֱGRAMʼַ
	LCD_WriteReg(0x53, 0x013F); //ֱGRAMַ
}
/*****************************************************************************
** : LCD_DrawLine
** : ָλûһ
				x1,y1:  x2,y2:յ 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DrawLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2)
{
	uint16_t t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; 				// 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; 		//õ 
	else if(delta_x==0)incx=0;	//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;	//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )	// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}
/*****************************************************************************
** : LCD_DrawLine
** : ָλûһָСԲ
				(x,y):ĵ 	 r    :뾶
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Draw_Circle(uint8_t x0,uint16_t y0,uint8_t r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a);             //3           
		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0-a,y0+b);             //1       
		LCD_DrawPoint(x0-b,y0-a);             //7           
		LCD_DrawPoint(x0-a,y0-b);             //2             
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0-b);             //5
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a,y0+b);
	}
} 
/*****************************************************************************
** : LCD_Fill
** : ָָɫ
				С:  (xend-xsta)*(yend-ysta) 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Fill(uint8_t xsta,uint16_t ysta,uint8_t xend,uint16_t yend,uint16_t color)
{                    
    uint32_t n;

	LCD_SetDisplayWindow(xsta,ysta,xend,yend);	 //ô		 									
//	LCD_SetCursor(xsta,ysta);//ùλ  
	LCD_WriteRAM_Prepare();  //ʼдGRAM	 	   	   
	n=(uint32_t)(yend-ysta+1)*(xend-xsta+1);    
	while(n--){Write_Dat(color);}//ʾɫ. 
	//ָ
	LCD_SetDisplayWindow(0x00,0x00,0xEF,0x13F);	 //ָС		     
}
/*****************************************************************************
** : LCD_Delay
** : LCDʱ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Delay (uint32_t nCount)
{
	uint16_t i;	 	
	for (i=0;i<nCount*100;i++);
}
/*********************************************************************************************************
** End of File
*********************************************************************************************************/
